Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/ConflictResolver.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/ConflictResolver.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/ConflictResolver.java	(revision 15582)
@@ -24,4 +24,5 @@
 import org.openstreetmap.josm.plugins.czechaddress.PrimUtils;
 import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.AddressElement;
+import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.ElementWithHouses;
 import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.House;
 import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.Street;
@@ -134,4 +135,9 @@
         candPickButton.setText("     ");
         candPickButton.setEnabled(false);
+        candPickButton.addActionListener(new java.awt.event.ActionListener() {
+            public void actionPerformed(java.awt.event.ActionEvent evt) {
+                candPickButtonActionPerformed(evt);
+            }
+        });
 
         mainPickButton.setText("     ");
@@ -212,4 +218,13 @@
     }
 
+    public void focusElement(AddressElement elem) {
+        int index = Collections.binarySearch(conflictModel.elements, elem);
+        if (index >= 0) {
+            mainField.setSelectedIndex(index);
+            mainField.repaint();
+            setVisible(true);
+        }
+    }
+
     private void reassignButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reassignButtonActionPerformed
 
@@ -258,6 +273,12 @@
 
     private void mainPickButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mainPickButtonActionPerformed
-        // TODO add your handling code here:
+        if (mainField.getSelectedItem() instanceof House)
+            FactoryDialog.getInstance().setSelectedHouse((House) mainField.getSelectedItem());
     }//GEN-LAST:event_mainPickButtonActionPerformed
+
+    private void candPickButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_candPickButtonActionPerformed
+        if (candField.getSelectedItem() instanceof House)
+            FactoryDialog.getInstance().setSelectedHouse((House) candField.getSelectedItem());
+    }//GEN-LAST:event_candPickButtonActionPerformed
 
     // Variables declaration - do not modify//GEN-BEGIN:variables
@@ -279,6 +300,6 @@
 
         public void elementChanged(AddressElement elem) {
-            String delStr = Reasoner.getInstance().inConflict(elem) ? " in conflict" : " no conflict";
-            logger.log(Level.FINER, "hook: element changed", elem.getName() + delStr);
+            if (!(elem instanceof House)) return;
+            logger.log(Level.FINER, "hook: element changed", elem.getName());
 
             if (Reasoner.getInstance().inConflict(elem))
@@ -289,6 +310,6 @@
 
         public void primitiveChanged(OsmPrimitive prim) {
-            String delStr = Reasoner.getInstance().inConflict(prim) ? " in conflict" : " no conflict";
-            logger.log(Level.FINER, "hook: primitive changed", AddressElement.getName(prim) + delStr);
+            if (!House.isMatchable(prim)) return;
+            logger.log(Level.FINER, "hook: primitive changed", AddressElement.getName(prim));
 
             if (Reasoner.getInstance().inConflict(prim))
@@ -333,9 +354,9 @@
 
         public void put(OsmPrimitive prim) {
-            int index = Collections.binarySearch(primitives, prim, new PrimUtils());
+            int index = Collections.binarySearch(primitives, prim, PrimUtils.comparator);
             if (index < 0) {
                 logger.log(Level.FINE, "conflicts: adding primitive",
-                                        "[" + String.valueOf(-index-1) + "]=„"
-                                        + AddressElement.getName(prim) + "“");
+                                       "["+String.valueOf(-index-1)+"]=„"
+                                        +AddressElement.getName(prim) + "“");
                 primitives.add(-index-1, prim);
                 
@@ -452,5 +473,5 @@
             List<OsmPrimitive> conflPrims = new NotNullList<OsmPrimitive>();
             conflPrims.addAll(Reasoner.getInstance().getCandidates(selElem));
-            Collections.sort(conflPrims, new PrimUtils());
+            Collections.sort(conflPrims, PrimUtils.comparator);
             candField.setModel(new CandidatesModel<OsmPrimitive>(conflPrims));
 
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/FactoryDialog.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/FactoryDialog.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/FactoryDialog.java	(revision 15582)
@@ -96,14 +96,22 @@
             keepOddityCheckBox.setEnabled(true);
             return;
-        }
-        
-/*      if (message == MESSAGE_REASONER_REASONED) {
-            ensureConsistencyButton.setEnabled(true);
-        }
-        
-        if (message == MESSAGE_MATCHES_CHANGED || message == MESSAGE_CONFLICT_CHANGED) {
-            houseModel.notifyAllListeners();
-            return;
-        }*/
+        }        
+    }
+
+    public void setSelectedHouse(House house) {
+
+        for (int i=0; i<streetModel.getSize(); i++)
+            if (streetModel.getElementAt(i) == house.getParent()) {
+                streetComboBox.setSelectedIndex(i);
+                streetComboBox.repaint();
+                break;
+            }
+
+        for (int i=0; i<houseModel.getSize(); i++)
+            if (houseModel.getHouseAt(i) == house) {
+                houseList.setSelectedIndex(i);
+                houseList.ensureIndexIsVisible(i);
+                break;
+            }
     }
 
@@ -111,6 +119,5 @@
         if (houseList.getSelectedValue() instanceof House)
             return (House) houseList.getSelectedValue();
-        else
-            return null;
+        return null;
     }
 
@@ -138,8 +145,8 @@
         int index = houseList.getSelectedIndex();
 
-        index++;
-        Object current;
-        while ( (current = houseModel.getElementAt(index)) != null
-              && Reasoner.getInstance().translate((House) current) != null)
+        index++; // Initial kick to do at least one move.
+        House current;
+        while ( (current = houseModel.getHouseAt(index))  != null
+             && Reasoner.getInstance().translate(current) != null)
             index++;
 
@@ -171,6 +178,6 @@
                 newNum = Integer.valueOf(newStr);
 
-            } while ( (oldNum + newNum) % 2 == 1 &&
-                      houseList.getSelectedIndex() != 0 );
+            } while ((oldNum + newNum) % 2 == 1 &&
+                     houseList.getSelectedIndex() != 0);
             
         } catch (Exception exp) {}
@@ -184,10 +191,11 @@
     }
 
+    public boolean selectionListenerActivated = true;
     public void selectionChanged(Collection<? extends OsmPrimitive> newSelection) {
 
+        if (!selectionListenerActivated) return;
         if (newSelection.size() != 1) return;
 
         OsmPrimitive selectedPrim = (OsmPrimitive) newSelection.toArray()[0];
-
         String streetName;
 
@@ -215,5 +223,5 @@
         for (House currHouse : selectedStreet.getHouses()) {
 
-            int currQuality = currHouse.getMatchQuality(selectedPrim);
+            int currQuality = currHouse.getQ(selectedPrim);
 
             if (currQuality > bestQuality) {
@@ -225,4 +233,5 @@
         if (bestHouse == null) return;
         houseList.setSelectedValue(bestHouse, true);
+        houseList.ensureIndexIsVisible(houseList.getSelectedIndex());
         houseModel.notifyAllListeners();
     }
@@ -313,19 +322,8 @@
             Reasoner r = Reasoner.getInstance();
 
-            if (r.translate(getSelectedHouse()) != null) {
+            if (r.translate(getSelectedHouse()) != null)
                 MapUtils.zoomTo(r.translate(getSelectedHouse()));
-                return;
-            }
-
-            // TODO: The following code does not work... for some reason.
-/*            List<Match> getConflicts = r.getConflictsForElement(getSelectegetConflicts if (getConflicts != null) {
-                List<OsmPrimitive> toZoom
-                        = new ArrayList<OsmPrimitive>(getConflicts.size());
-                for (Match conflict : getConflicts)
-                    toZoom.add(conflict.prim);
-
-                MapUtils.zoomToMany(toZoom);
-                return;
-*/
+            else
+                ConflictResolver.getInstance().focusElement(getSelectedHouse());
         }
     }//GEN-LAST:event_houseListClicked
@@ -344,35 +342,28 @@
         houseModel.notifyAllListeners();
     }
-
     public void primitiveChanged(OsmPrimitive prim) {}
-
-    public void resonerReseted() {
-        throw new UnsupportedOperationException("Not supported yet.");
-    }
+    public void resonerReseted() {}
+
+//==============================================================================
 
     private class StreetListRenderer extends DefaultListCellRenderer {
-
-        Font plainFont = null;
-        Font boldFont = null;
-
         @Override
         public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
             Component c = super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
 
-            if (plainFont == null) plainFont = getFont().deriveFont(Font.PLAIN);
-            if (boldFont  == null)  boldFont = getFont().deriveFont(Font.BOLD);
-
             if (value instanceof Street) {
-                setFont(plainFont);
+                setFont(getFont().deriveFont(Font.PLAIN));
                 setText(((Street) value).getName());
                 
             } else if (value instanceof ElementWithHouses) {
-                setFont(boldFont);
+                setFont(getFont().deriveFont(Font.BOLD));
                 setText("[" + ((ElementWithHouses) value).getName() + "]");
             }
-
+            
             return c;
         }
     }
+
+//==============================================================================
 
     private class HouseListRenderer extends DefaultListCellRenderer {
@@ -392,6 +383,4 @@
             if (boldFont == null) boldFont = getFont().deriveFont(Font.BOLD);
 
-            Reasoner r = Reasoner.getInstance();
-
             if (value instanceof House) {
                 House house = (House) value;
@@ -400,8 +389,8 @@
                 setFont(plainFont);
 
-                if (r.inConflict(house))
+                if (Reasoner.getInstance().inConflict(house))
                     setIcon(envelopeExclIcon);
 
-                else if (r.translate(house) == null) {
+                else if (Reasoner.getInstance().translate(house) == null) {
                     setIcon(envelopeStarIcon);
                     setFont(boldFont);
@@ -414,4 +403,6 @@
     }
 
+//==============================================================================
+
     private class AllStreetProvider extends ElementWithHouses {
         public AllStreetProvider() {
@@ -431,15 +422,5 @@
             super("nepřiřazené domy");
             Reasoner.getInstance().addListener(this);
-            rebuild();
-        }
-
-        @Override
-        public void setHouses(List<House> houses) {
-            this.houses = houses;
-        }
-
-
-        public void rebuild() {
-            houses.clear();
+
             for (AddressElement house : Reasoner.getInstance().getUnassignedElements())
                 if (house instanceof House)
@@ -452,18 +433,19 @@
         public void primitiveChanged(OsmPrimitive prim) {}
         public void elementChanged(AddressElement elem) {
-            if (!(elem instanceof House))
-                return;
+            if (!(elem instanceof House)) return;
             House house = (House) elem;
+            int index = Collections.binarySearch(houses, house);
             
-            if (Reasoner.getInstance().translate(house) != null)
-                houses.remove(house);
-            else if (!houses.contains(house)) {
-                houses.add(house);
-                Collections.sort(houses);
-            }
-        }
-
-
-    }
+            if (Reasoner.getInstance().translate(house) != null) {
+                if (index >= 0) houses.remove(index);
+            } else {
+                if (index < 0)  houses.add(-index-1, house);
+            }
+            
+            houseModel.notifyAllListeners();
+        }
+    }
+
+//==============================================================================
 
     private class StreetListModel extends HalfCookedComboBoxModel {
@@ -481,6 +463,4 @@
         }
 
-
-
         public int getSize() {
             if (parent == null) return 0;
@@ -491,8 +471,8 @@
             if (parent == null) return;
 
-            selected = parent;
-            this.parent = parent;
+            this.selected = parent;
+            this.parent   = parent;
+            
             metaElem.set(0, parent);
-
             metaElem.get(1).setHouses(parent.getAllHouses());
             notifyAllListeners();
@@ -500,7 +480,5 @@
 
         public Object getElementAt(int index) {
-
             if (parent == null) return null;
-            if (index <  0) return null;
 
             if (index < metaElem.size())
@@ -508,5 +486,5 @@
 
             index -= metaElem.size();
-            // Now the index points to the list of streets
+
             if (index < parent.getStreets().size())
                 return parent.getStreets().get(index);
@@ -526,5 +504,12 @@
     }
 
-    private class HouseListModel extends HalfCookedListModel {
+//==============================================================================
+
+    private class HouseListModel extends HalfCookedListModel
+                                 implements ReasonerListener {
+
+        public HouseListModel() {
+            Reasoner.getInstance().addListener(this);
+        }
 
         public int getSize() {
@@ -549,4 +534,13 @@
             return getHouseAt(index);
         }
+
+        public void primitiveChanged(OsmPrimitive prim) {}
+        public void elementChanged(AddressElement elem) {
+            notifyAllListeners();
+        }
+
+        public void resonerReseted() {
+            notifyAllListeners();
+        }
     }
 }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/GroupManipulatorDialog.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/GroupManipulatorDialog.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/GroupManipulatorDialog.java	(revision 15582)
@@ -1,4 +1,7 @@
 package org.openstreetmap.josm.plugins.czechaddress.gui;
 
+import org.openstreetmap.josm.data.osm.OsmPrimitive;
+import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.AddressElement;
+import org.openstreetmap.josm.plugins.czechaddress.gui.utils.UniversalTreeRenderer;
 import java.awt.event.ActionEvent;
 import java.awt.event.KeyEvent;
@@ -9,4 +12,5 @@
 import org.openstreetmap.josm.plugins.czechaddress.StatusListener;
 import org.openstreetmap.josm.plugins.czechaddress.intelligence.Reasoner;
+import org.openstreetmap.josm.plugins.czechaddress.intelligence.ReasonerListener;
 import org.openstreetmap.josm.plugins.czechaddress.proposal.Proposal;
 import org.openstreetmap.josm.plugins.czechaddress.proposal.ProposalContainer;
@@ -25,5 +29,5 @@
  * @see ConflictDatabase
  */
-public class GroupManipulatorDialog extends ExtendedDialog implements StatusListener {
+public class GroupManipulatorDialog extends ExtendedDialog implements ReasonerListener {
 
     private static GroupManipulatorDialog singleton = null;
@@ -33,4 +37,6 @@
         return singleton;
     }
+
+    private ProposalDatabase database = null;
 
     /**
@@ -52,7 +58,4 @@
         setAlwaysOnTop(false);
 
-        // Start receiving plugin-wide messages.
-        CzechAddressPlugin.addStatusListener(this);
-
         // TODO: Why does it always crash if the modality is set in constructor?
         setModal(false);
@@ -63,38 +66,24 @@
         super.buttonAction(evt);
         if (getValue() == 1)
-            ((ProposalDatabase) proposalTree.getModel()).applyAll();
-    }
-
-    public void pluginStatusChanged(int message) {
-        /*if (message == StatusListener.MESSAGE_MATCHES_CHANGED) {
-            int retval = (new ExtendedDialog(Main.parent, "Změna umístění",
-                    "Došlo ke změně v přiřazení databáze.\n" +
-                    "Přejete si znovu načíst seznam navrhovaných změn?",
-                    new String[] {"Ano", "Ne"},
-                    new String[] {"ok.png", "cancel.png"})).getValue();
-
-            if (retval == 1)
-                recreateProposals();
-        }*/
+            database.applyAll();
     }
 
     @Override
-    public void setVisible(boolean b) {
-        if (!isVisible() && b)
+    public void setVisible(boolean visible) {
+
+        if (!isVisible() && visible) {
+            Reasoner.getInstance().addListener(this);
             recreateProposals();
-
-        if (b)
-            CzechAddressPlugin.addStatusListener(this);
-        else
-            CzechAddressPlugin.removeStatusListener(this);
-
-        super.setVisible(b);
+        } else
+            Reasoner.getInstance().removeListener(this);
+
+        super.setVisible(visible);
     }
 
     public void recreateProposals() {
-/*        locationTextField.setText(CzechAddressPlugin.getLocation().toString());
+        locationTextField.setText(CzechAddressPlugin.getLocation().toString());
         
-        Reasoner r = CzechAddressPlugin.getReasoner();
-        proposalTree.setModel(r.getProposals());*/
+        database = Reasoner.getInstance().getProposals();
+        proposalTree.setModel(database);
     }
 
@@ -210,3 +199,25 @@
     // End of variables declaration//GEN-END:variables
 
+    public void elementChanged(AddressElement elem) {
+        for (ProposalContainer container : database.getContainers()) {
+            if (Reasoner.getInstance().translate(elem) == container.getTarget()) {
+                recreateProposals();
+                break;
+            }
+        }
+    }
+
+    public void primitiveChanged(OsmPrimitive prim) {
+        for (ProposalContainer container : database.getContainers()) {
+            if (container.getTarget() == prim) {
+                recreateProposals();
+                break;
+            }
+        }
+    }
+
+    public void resonerReseted() {
+        recreateProposals();
+    }
+
 }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/LocationSelector.form
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/LocationSelector.form	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/LocationSelector.form	(revision 15582)
@@ -1,9 +1,9 @@
 <?xml version="1.0" encoding="UTF-8" ?>
 
-<Form version="1.3" type="org.netbeans.modules.form.forminfo.JDialogFormInfo">
+<Form version="1.3" maxVersion="1.3" type="org.netbeans.modules.form.forminfo.JDialogFormInfo">
   <Properties>
     <Property name="title" type="java.lang.String" value="V&#xfd;b&#x11b;r um&#xed;st&#x11b;n&#xed;"/>
     <Property name="modal" type="boolean" value="true"/>
-    <Property name="name" type="java.lang.String" value="locationSelector"/>
+    <Property name="name" type="java.lang.String" value="locationSelector" noResource="true"/>
   </Properties>
   <SyntheticProperties>
@@ -41,7 +41,7 @@
                   <EmptySpace max="-2" attributes="0"/>
                   <Group type="103" groupAlignment="1" attributes="0">
-                      <Component id="castObceComboBox" pref="340" max="32767" attributes="0"/>
-                      <Component id="obecComboBox" pref="340" max="32767" attributes="0"/>
-                      <Component id="oblastComboBox" pref="340" max="32767" attributes="0"/>
+                      <Component id="suburbComboBox" pref="341" max="32767" attributes="0"/>
+                      <Component id="vitociComboBox" pref="341" max="32767" attributes="0"/>
+                      <Component id="oblastComboBox" pref="341" max="32767" attributes="0"/>
                   </Group>
               </Group>
@@ -58,10 +58,10 @@
                   <Group type="103" groupAlignment="3" attributes="0">
                       <Component id="obecLabel" alignment="3" min="-2" max="-2" attributes="0"/>
-                      <Component id="obecComboBox" alignment="3" min="-2" pref="25" max="-2" attributes="0"/>
+                      <Component id="vitociComboBox" alignment="3" min="-2" pref="25" max="-2" attributes="0"/>
                   </Group>
                   <EmptySpace max="-2" attributes="0"/>
                   <Group type="103" groupAlignment="3" attributes="0">
                       <Component id="castObceLabel" alignment="3" min="-2" max="-2" attributes="0"/>
-                      <Component id="castObceComboBox" alignment="3" min="-2" pref="25" max="-2" attributes="0"/>
+                      <Component id="suburbComboBox" alignment="3" min="-2" pref="25" max="-2" attributes="0"/>
                   </Group>
                   <EmptySpace max="32767" attributes="0"/>
@@ -81,5 +81,5 @@
           </Events>
         </Component>
-        <Component class="javax.swing.JComboBox" name="castObceComboBox">
+        <Component class="javax.swing.JComboBox" name="suburbComboBox">
           <Properties>
             <Property name="model" type="javax.swing.ComboBoxModel" editor="org.netbeans.modules.form.editors2.ComboBoxModelEditor">
@@ -88,8 +88,8 @@
           </Properties>
           <Events>
-            <EventHandler event="itemStateChanged" listener="java.awt.event.ItemListener" parameters="java.awt.event.ItemEvent" handler="castObceComboBoxItemStateChanged"/>
+            <EventHandler event="itemStateChanged" listener="java.awt.event.ItemListener" parameters="java.awt.event.ItemEvent" handler="suburbComboBoxItemStateChanged"/>
           </Events>
         </Component>
-        <Component class="javax.swing.JComboBox" name="obecComboBox">
+        <Component class="javax.swing.JComboBox" name="vitociComboBox">
           <Properties>
             <Property name="model" type="javax.swing.ComboBoxModel" editor="org.netbeans.modules.form.editors2.ComboBoxModelEditor">
@@ -98,5 +98,5 @@
           </Properties>
           <Events>
-            <EventHandler event="itemStateChanged" listener="java.awt.event.ItemListener" parameters="java.awt.event.ItemEvent" handler="obecComboBoxItemStateChanged"/>
+            <EventHandler event="itemStateChanged" listener="java.awt.event.ItemListener" parameters="java.awt.event.ItemEvent" handler="vitociComboBoxItemStateChanged"/>
           </Events>
         </Component>
@@ -113,5 +113,5 @@
         <Component class="javax.swing.JLabel" name="oblastLabel">
           <Properties>
-            <Property name="text" type="java.lang.String" value="Oblast:"/>
+            <Property name="text" type="java.lang.String" value="ORP:"/>
           </Properties>
         </Component>
